链接:



Nested Dolls

Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 1876    Accepted Submission(s): 524

Problem Description
Dilworth is the world’s most prominent collector of Russian nested dolls: he literally has thousands of them! You know, the wooden hollow dolls of different sizes of which the smallest doll is contained in the second smallest, and this doll is in turn contained
in the next one and so forth. One day he wonders if there is another way of nesting them so he will end up with fewer nested dolls? After all, that would make his collection even more magnificent! He unpacks each nested doll and measures the width and height
of each contained doll. A doll with width w1 and height h1 will fit in another doll of width w2 and height h2 if and only if w1 < w2 and h1 < h2. Can you help him calculate the smallest number of nested dolls possible to assemble from his massive list of measurements?
 
Input
On the first line of input is a single positive integer 1 <= t <= 20 specifying the number of test cases to follow. Each test case begins with a positive integer 1 <= m <= 20000 on a line of itself telling the number of dolls in the test case. Next follow 2m
positive integers w1, h1,w2, h2, . . . ,wm, hm, where wi is the width and hi is the height of doll number i. 1 <= wi, hi <= 10000 for all i.
 
Output
For each test case there should be one line of output containing the minimum number of nested dolls possible.
 
Sample Input
4
3
20 30 40 50 30 40
4
20 30 10 10 30 20 40 50
3
10 30 20 20 30 10
4
10 10 20 30 40 50 39 51
 
Sample Output
1
2
3
2
 
Source
 
Recommend
lcy


题意:


      给你 N 个娃娃, 每个娃娃有特定的 w 和 h

      当且仅当 d1.w < d2.w && d1.h < d2.h , d1 才可以放入 d2中

      问:最少还可以剩下几个娃娃

算法:应该是要用 dp 做了,这里用贪心Orz

最后发现都一样,贪心还是 DP , 分析了 hdu 1257 就知道了Orz

思路:


      感觉类似于hdu 1257 最少拦截系统  的非DP解法【贪心求解】 hdu
1257 题解


      先对娃娃们排序:先按照 w 从大到小排序, w 相同,则按照 h 从小到大排序

关于排序:


           先按照 w 从大到小排序可以理解吧【把小的嵌套到大的当中去】

           对于 w 相同时 h 从小到大排序

           如果 m 个 w 相同, 那么必然是嵌套在 m 个不同的娃娃中

          【可能是比它大的,也可能是它本身】

           先选择 h 最小的嵌入到前面能够满足条件的娃娃中,

           再新用一个娃娃嵌套 h 倒数第二小的娃娃,

           那么这时嵌套了第二个娃娃的东西,一定能比已经嵌套了第个一的更能嵌套其它的娃娃 w 相同 ,而 h 更优【h大】
         
           比如说这堆娃娃有这样几个娃娃

           5

           30 400  (1)

           10 200  (1)

           10 300  (2) w 相同,必然重新嵌入不同的娃娃

           9 250   (2)

           8 250   (3)

           那么最优的结果就是 3,

           第一个娃娃嵌套第二个;

           第三个娃娃嵌套第四个;

           第五个娃娃单独嵌套。





           但是如果你按照 w 相同时 h 从大到小排序就是这样

           5

           30 400  (1)

           10 300  (1)

           10 200  (2)

           9 250   (3)

           8 250   (4)

           一样的数据, 答案是 4

code:

/*****************************************************************************************

E	Accepted	540 KB	343 ms	C++	1172 B	2013-08-04 21:16:03

题意:给你 N 个娃娃, 每个娃娃有特定的 w 和 h
当且仅当 d1.w < d2.w && d1.h < d2.h , d1 才可以放入 d2中
问:最少还可以剩下几个娃娃
算法:应该是要用 dp 做了,这里用贪心Orz
思路:感觉类似于导弹拦截系统
先对娃娃们排序:先按照 w 从大到小排序, w 相同,则按照 h 从小到大排序
关于排序:先按照 w 从大到小排序可以理解吧【把小的嵌套到大的当中去】
对于 w 相同时 h 从小到大排序
如果 m 个 w 相同, 那么必然是嵌套在 m 个不同的娃娃中
【可能是比它大的,也可能是它本身】
先选择 h 最小的嵌入到前面能够满足条件的娃娃中,
再新用一个娃娃嵌套 h 倒数第二小的娃娃,
那么这时嵌套了第二个娃娃的东西,一定能比已经嵌套了第个一的更能嵌套其它的娃娃 w 相同 ,而 h 更优【h大】
比如说这堆娃娃有这样几个娃娃
5
30 400 (1)
10 200 (1)
10 300 (2) w 相同,必然重新嵌入不同的娃娃
9 250 (2)
8 250 (3)
那么最优的结果就是 3,
第一个娃娃嵌套第二个;
第三个娃娃嵌套第四个;
第五个娃娃单独嵌套。 但是如果你按照 w 相同时 h 从大到小排序就是这样
5
30 400 (1)
10 300 (1)
10 200 (2)
9 250 (3)
8 250 (4)
一样的数据, 答案是 4 *****************************************************************************************/
#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<iostream>
using namespace std; const int maxn = 20000+10;
const int INF = 10000+10; struct Node
{
int w,h;
}node[maxn], dp[maxn]; bool cmp(Node a, Node b)
{
if(a.w == b.w) return a.h < b.h;
else return a.w > b.w;
} int main()
{
int T;
int n;
scanf("%d", &T);
while(T--)
{
scanf("%d", &n);
for(int i = 0; i < n; i++)
{
scanf("%d%d", &node[i].w, &node[i].h);
dp[i].w = dp[i].h = INF; //假设初始化有 N 个可以嵌套的娃娃
}
sort(node, node+n, cmp);
//for(int i = 0; i < n; i++) printf("%d %d\n", node[i].w, node[i].h); printf("\n"); for(int i = 0; i < n; i++)
{
int j = 0;
while(dp[j].w <= node[i].w || dp[j].h <= node[i].h) j++;
dp[j].w = node[i].w; //不断更新为当前情况
dp[j].h = node[i].h;
} // for(int i = 0; i < n; i++) printf("%d %d\n", dp[i].w, dp[i].h); printf("\n"); int ans = 0;
for(int i = 0; i < n; i++)
if(dp[i].h != INF) //看有几个嵌套过
ans++; printf("%d\n", ans);
}
return 0;
}




hdu 1677 Nested Dolls【贪心解嵌套娃娃问题】的更多相关文章

  1. HDU 1677 Nested Dolls

    过了之后感觉曾经真的做过这样的类型的题. 之前一直非常疑惑二级排序的优先级问题,如今发现二级排序真的没有绝对的优先级. 对于此题,若按W排序,则有1到i件物品的W均小于等于第i+1件物品(设为A)的W ...

  2. Nested Dolls 贪心 + dp

    G: Nested Dolls Time Limit: 1 Sec     Memory Limit: 128 Mb     Submitted: 99     Solved: 19 Descript ...

  3. HDU 1277 Nested Dolls

    题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1677 题意: 玩俄罗斯套娃,问最后至少还剩几个. 题解: 这题可以和拦截导弹做对比,因为这里是二维的 ...

  4. hdu----(1677)Nested Dolls(DP/LIS(二维))

    Nested Dolls Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Tota ...

  5. 子查询解嵌套in改写为exists

    SELECT * FROM (SELECT pubformdat0_.id id332_, pubformdat0_.domain_id domain2_332_, pubformdat0_.proc ...

  6. HDU 1677

    Nested Dolls Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Tota ...

  7. HDU 4442 Physical Examination(贪心)

    HDU 4442 Physical Examination(贪心) 题目链接http://acm.split.hdu.edu.cn/showproblem.php?pid=4442 Descripti ...

  8. [LeetCode] Flatten Nested List Iterator 压平嵌套链表迭代器

    Given a nested list of integers, implement an iterator to flatten it. Each element is either an inte ...

  9. [LeetCode] Nested List Weight Sum 嵌套链表权重和

    Given a nested list of integers, return the sum of all integers in the list weighted by their depth. ...

随机推荐

  1. 参数数组(params)的用法

    使用参数数组的注意事项: 1. 只能在一维数组上使用params关键字. 2. 不能重载一个只基于params关键字的方法.params关键字不构成方法的签名的一部分. 如: //编译时错误:重复访问 ...

  2. 双线机房双网卡双ip 路由设置

    做互联网网站,最头疼的事情之一就是电信和网通的互联互不通了,为了能够让北方网通和南方电信用户都可以快速的访问网站,解决办法就是托管 到双线机房.双线机房有两类,一类是通过BGP技术实现互联互通,服务器 ...

  3. 匿名内部类 , Iterable<T> 和 Iterator<T>

    package generic; import java.util.ArrayList; import java.util.Arrays; import java.util.Collection; i ...

  4. JAVA工具类 UUID

    UUID:通用惟一识别:Universally Unique Identifier: 在一台机器上生成的数字,它保证对在同一时空中的所有机器都是唯一的. GUID是一个128位长的数字,一般用16进制 ...

  5. linux 从百度网盘下载文件的方法

    linux 从百度网盘下载文件的方法 发表于2015 年 月 日由shenwang 方法1.wget wget是在Linux下开发的开放源代码的软件,作者是Hrvoje Niksic,后来被移植到包括 ...

  6. Android 开发 -------- 自己定义View 画 五子棋

    自己定义View  实现 五子棋 配图: watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvbG92ZV9KYXZjX3lvdQ==/font/5a6L5L2T ...

  7. Storm系统架构以及代码结构学习

    转自:http://blog.csdn.net/androidlushangderen/article/details/45955833 storm学习系列:http://blog.csdn.net/ ...

  8. 第二百二十八节,jQuery EasyUI,TreeGrid(树形表格)组件

    jQuery EasyUI,TreeGrid(树形表格)组件 学习要点: 1.加载方式 2.属性列表 3.事件列表 4.方法列表 本节课重点了解 EasyUI 中 TreeGrid(树形表格)组件的使 ...

  9. ACM 博弈(难)题练习 (第二弹)

    第一弹: Moscow Pre-Finals Workshop 2016 - Kent Nikaido Contest 1 Problem K. Pyramid Game http://opentra ...

  10. 【BZOJ】3391: [Usaco2004 Dec]Tree Cutting网络破坏(dfs)

    http://www.lydsy.com/JudgeOnline/problem.php?id=3391 显然判断每个点只需要判断子树是否小于等于n/2即可 那么我们虚拟一个根,然后计算每个子树的si ...